
//	Copyright 2011 PaletteSoft LLC

//	******  ******* *     * *******  *****  *******                           
//	*     * *       *     *    *    *     * *                                 
//	*     * *       *     *    *    *       *                                 
//	*     * ******* *     *    *    *       *******                           
//	*     * *        *   *     *    *       *                                 
//	*     * *         * *      *    *     * *                                 
//	******  *******    *    *******  *****  *******                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2010.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2011.02.15
//	EVK쐬
// ===========================================================================

// ***************************************************************************
// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************
// ***************************************************************************

	//	*****  *****

#include	"string.h"													//	񑀍

	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾
#include	"version.h"													//	o[Wԍ̒`

	//	*****  *****

#include	"device.h"													//	foCX

#include	"main.h"													//	C@c@̒Ő錾ϐ͊O錾ɂȂ

// ***************************************************************************
// *	zdl															 *
// ***************************************************************************
/*
	t`qsj^u					PIC16F1823 CLOCK INTRCIO 32MHz

	@{\@

	PORT	FUNC		pr			l
	--------------------------------------------------------------------------
	RA0		RA0/ICSPDAT	SW				0:On, 1:Off		Programing Data
	RA1		RA1/ICSPCLK	SW				0:On, 1:Off		Programing Clock
	RA2		RA2			SW				0:On, 1:Off
	RA3		RA3			ETC				0:On, 1:Off
	RA4		RA4			LCD				E
	RA5		RA5			LCD				DB5

	RC0		RC0			LCD				DB4
	RC1		RC1			LCD				DB6
	RC2		RC2			LCD				DB7
	RC3		RC3			LCD				RS
	RC4		TX			UART			TXD
	RC5		RX			UART			RXD
*/

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	***** P *****

__CONFIG (	FCMEN_OFF													//	tF[Z[tNbNj^֎~
		&	IESO_OFF													//	ONbNXCb`I[o[֎~
		&	CLKOUTEN_OFF												//	RA4/CLKOUT[qRA4ŗp
		&	BOREN_ON													//	uEAEgoL
		&	CPD_OFF														//	f[^iEEPROMj̃veNg֎~
		&	CP_OFF														//	vÕveNg֎~
		&	MCLRE_OFF													//	RA3/_MCLR[qRA3ŗp
		&	PWRTE_ON													//	p[Abv^C}싖
		&	WDTE_OFF													//	EHb`hbO^C}֎~
		&	FOSC_INTOSC													//	NbNpRA5/CLKINRA5ŗp
);

	//	***** Q *****											//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF														//	d݂͗pȂ
		&	BORV_19														//	uEAEgod1.9V
		&	STVREN_ON													//	X^bNG[̓Zbg
		&	PLLEN_ON													//	PLL
		&	WRT_OFF														//	tbVȏݎ̃veNg
);

	//	***** ʏ *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

//	***************************************************************************
//	***************************************************************************
//	*	s														  *
//	***************************************************************************
//	***************************************************************************

//				0	  1		2	  3		4	  5		6	  7
__EEPROM_DATA ( 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);		//	EEPROMli݋@ł̏݁j

// ***************************************************************************
// ***************************************************************************
// *	Œl																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	\																 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	e[u															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************
// ***************************************************************************


// ***************************************************************************
// ***************************************************************************
// *	{															 *
// ***************************************************************************
// ***************************************************************************

//	
//	
//
// 		{
//
//	
//	
void	DevStd______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	}CRfoCXݒ肵܂B
//============================================================================
void	DevInit(void)
{
	//	***** ͂߂ *****

	di();																//	荞݋֎~

	//	***** Uݒ *****

//				76543210
	OSCCON	= 0b01110000;												//	NbNWlg@c@okkHLȂ̂ŎRQlg

	//	***** |[g *****

//				76543210
	ANSELA	= 0b00000000;												//	ăfW^óiAiO͋֎~j
	PORTA	= 0b00000000;												//	o̓f[^ݒ
	TRISA	= 0b00001111;												//	o͕ݒ
	WPUA	= 0b00001111;												//	vAbvݒ

																		//	RA0	SW		in	- Pup	0:On, 1:Off
																		//	RA1	SW		in	- Pup	0:On, 1:Off
																		//	RA2	SW		in	- Pup	0:On, 1:Off
																		//	RA3	ETC		in	- Pup	0:On, 1:Off
																		//	RA4	LCD_E	out	0 ---	Active H
																		//	RA5	LCD_DB5	out	0 ---	Active H
																		//	RA6	-----	---	- ---	i蓖āj
																		//	RA7	-----	---	- ---	i蓖āj

//				76543210
	ANSELC	= 0b00000000;												//	ăfW^óiAiO͋֎~j
	PORTC	= 0b00000000;												//	o̓f[^ݒ
	TRISC	= 0b00110000;												//	o͕ݒ
	WPUC	= 0b00000000;												//	vAbvݒ

																		//	RC0	LCD_DB4	out	0 ---	Active H
																		//	RC1	LCD_DB6	out	0 ---	Active H
																		//	RC2	LCD_DB7	out	0 ---	Active H
																		//	RC3	LCD_RS	out	0 ---	Active H
																		//	RC4	UART_TX	in	- ---	Transmit data
																		//	RC5	UART_RX	in	- ---	Receive data
																		//	RC6	-----	---	- ---	i蓖āj
																		//	RC7	-----	---	- ---	i蓖āj

	nWPUEN = 0;															//	vAbv䋖

	//	***** 荞 *****

	INTCON	= 0b01000000;												//	荞݋֎~Aӊ荞݋A{IȊ荞݂̋֎~Ɨv

	PIE1	= 0b00000000;												//	ӌʊ荞݋֎~îPj
	PIR1	= 0b00000000;												//	ӌʊ荞ݗv

	PIE2	= 0b00000000;												//	ӌʊ荞݋֎~ÂQ
	PIR2	= 0b00000000;												//	ӌʊ荞ݗv

	//	***** ܂ *****

	CLRWDT();															//	EHb`hbO^C}̃tbViCIȍ@j
}

//	
//	
//
// 		M
//
//	
//	
void	DevSig______(void) {}											//	op֐

//============================================================================
//	kbcMFd
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	dM𐧌䂵܂B
//============================================================================
void	DevSigLcdE_H(void)	{	LATA4 = 1;	}							//	gJ
void	DevSigLcdE_L(void)	{	LATA4 = 0;	}							//	kJ

//============================================================================
//	kbcMFqr
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	qrM𐧌䂵܂B
//============================================================================
void	DevSigLcdRS_H(void)	{	LATC3 = 1;	}							//	gJ
void	DevSigLcdRS_L(void)	{	LATC3 = 0;	}							//	kJ

//============================================================================
//	kbcMFca
//----------------------------------------------------------------------------
//	́F	݃f[^ilra킹̂PoCgf[^j
//	óF	
//----------------------------------------------------------------------------
//	lF	caM𐧌䂵܂B
//			Srbgł͏ʂSrbĝ݈Ӗ܂B
//
//			̓|[gtooȂ̂ŁArbg𒼎Aڃrbg
//			삵܂ib`WX^𗘗pjBWJȂ璲܂B
//============================================================================
void	DevSigLcdDB(UB Data)
{
	LATC2 = (Data & (UB)BIT07) ? 1 : 0;									//	bit7(MSB)
	LATC1 = (Data & (UB)BIT06) ? 1 : 0;									//	bit6
	LATA5 = (Data & (UB)BIT05) ? 1 : 0;									//	bit5
	LATC0 = (Data & (UB)BIT04) ? 1 : 0;									//	bit4
}

//============================================================================
//	XCb`̓ǂݏo
//----------------------------------------------------------------------------
//	́F	
//	óF	XCb`f[^ikra킹j
//----------------------------------------------------------------------------
//	lF	XCb`̏ԂǂݏoA_␳Ԃ܂B
//============================================================================
UB		DevSigSwRead(void)
{
	return((~PORTA) & (UB)(SW_BPS | SW_ETC));							//	XCb`ǂݏoĘ_␳sALӖ񂾂Ԃ܂
}

//	
//	
//
// 		Ԑ
//
//	
//	
void	DevTim______(void) {}											//	op֐

//============================================================================
//	~bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaiMs(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		__delay_ms(1);													//	Pҋ@
		CLRWDT();														//	EHb`hbO^C}̃tbV
	}
}

//============================================================================
//	bPʂ̑ҋ@
//----------------------------------------------------------------------------
//	́F	ҋ@ԁiO`QTTj
//	óF	
//----------------------------------------------------------------------------
//	lF	\tgEFA^C}𗘗pҋ@s܂B
//============================================================================
void	DevTimWaiSec(UB Time)
{
	while (Time --) {													//	ҋ@Ԃ菄
		DevTimWaiMs(250);												//	QTOҋ@
		DevTimWaiMs(250);												//	QTOҋ@
		DevTimWaiMs(250);												//	QTOҋ@
		DevTimWaiMs(250);												//	QTOҋ@
	}
}

//============================================================================
//	^C}̋N							^C}O	@WPXQʂ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}ݒ肵N܂Bߎl͖WƂĉB
//			荞ݐݒA͕ʊ֐ɂčs܂B
//============================================================================
void	DevTimCycInit(void)
{
	//	***** ͂߂ *****

	TMR0IE = 0;															//	^C}O荞݋֎~

	//	***** ݒ *****
//								 76------	   --543210
	OPTION_REG = (OPTION_REG & 0b11000000) | 0b00000111;				//	^C}OiNbNAvXP[ڑAQTUj

/*
	Cycle = ((Fosc / 4) * Prescaler) * Count
		  = ((32MHz / 4) * 256) * 256
		  = 0.125 * 65536
		  = 8192us
*/

	//	***** Jn *****

	TMR0 = 0;															//	^C}OJE^NA
	TMR0IF = 0;															//	^C}O荞ݗv
}

//============================================================================
//	^C}̊荞݋					^C}O
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}ɂ銄荞݂܂B{֐sɂȂ܂B
//============================================================================
void	DevTimCycEnaIpt(void)
{
	//	***** ^C}NA *****

	TMR0 = 0;															//	^C}OJE^NA
	TMR0IF = 0;															//	^C}O荞ݗv

	//	***** 荞݋ *****

	TMR0IE = 1;															//	^C}O荞݋
}

//============================================================================
//	^C}̊荞ݗvmFƃNA		^C}O
//----------------------------------------------------------------------------
//	́F	
//	óF	荞ݗvisqtd^e`krdj
//----------------------------------------------------------------------------
//	lF	t[^C}𗘗p^C}̃^CAEgԂ܂B
//			֎~𔺂Ȃ̂ŁA荞ݏ̓Oŗpł܂B
//============================================================================
BOOL	DevTimCycGetReq(void)
{
	if (T0IF) {															//	荞ݗvH
		T0IF = 0;														//	v
		return(TRUE);													//	荞ݗvL܂
	}
	else {																//	荞ݗv܂
		return(FALSE);													//	荞ݗv܂
	}
}

//	
//	
//
// 		uq`l
//
//	
//	
void	DevVrm______(void) {}											//	op֐

//============================================================================
//	uq`l̍sVtg
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	PsڂOsڂɍsVtg܂BPsڂ͋󔒍sɂȂ܂B
//			PUQs\̉tplpłB
//
//			Ԃ̐ƃeʂ̊֌WŊ̃p^[܂A
//			ėpIɍΑxxAxグƋ@ˑĂ܂܂B
//			RpC̎˂ĎĂ݂ƁA낢Ȏ킩܂B
//
//			̊֐͌XCɔzuĂ܂Ax̂߁A
//			VXe\ˑAJˑAfoCXˑ̏ɂȂĂ܂B
//			L̐ɂȂ̂ŃC䂩foCXɈړĂ܂B
//			ڐAsۂ͊g߂pł邩ۂ̊mFKvłB
//
//			Ql܂łɁAPIC16F1823/32MHzł
//			EDevVrmFeed_1	1066cycle=133.250us, +  0word,+0byteiP[Xj
//			EDevVrmFeed_2	 135cycle= 16.875us, + 39word,-7byte
//			EDevVrmFeed_3	  63cycle=  7.875us, -104word,-8byte
//			ɂȂ܂BȂAmemcpy/memset ͋p֐Ȃ̂őłp̂
//			΃vOeʂ̖ʂŗLɂȂꍇ܂B
//============================================================================

//	#define	DevVrmFeed_1	DevVrmFeed									//	h			ėp
//	#define	DevVrmFeed_2	DevVrmFeed									//			n[hEFA\Ɉˑ
	#define	DevVrmFeed_3	DevVrmFeed									//	h			J܂߁AVXe\Ɉˑ

//----------------------------------------------------------------------------
//	h																	 -
//----------------------------------------------------------------------------
void	DevVrmFeed_1(void)	
{
	memcpy(vMngVrm[0], vMngVrm[1], LCD_COL_TOTAL);						//	PsڂOsڂɃRs[
	memset(vMngVrm[1], CODE_SP, LCD_COL_TOTAL);							//	PsڂXy[XŖ
}

//----------------------------------------------------------------------------
//																	 -
//----------------------------------------------------------------------------
#define	mMngVrmCp(col)			vMngVrm[0][col] = vMngVrm[1][col]		//	PPʂ̃Rs[
#define	mMngVrmSp(col)			vMngVrm[1][col] = CODE_SP				//	Xy[XR[h̑
void	DevVrmFeed_2(void)
{
	mMngVrmCp( 0);	mMngVrmCp( 1);	mMngVrmCp( 2);	mMngVrmCp( 3);		//	PsڂOsڂɃRs[	 0 -  3
	mMngVrmCp( 4);	mMngVrmCp( 5);	mMngVrmCp( 6);	mMngVrmCp( 7);		//							 4 -  7
	mMngVrmCp( 8);	mMngVrmCp( 9);	mMngVrmCp(10);	mMngVrmCp(11);		//							 8 - 11
	mMngVrmCp(12);	mMngVrmCp(13);	mMngVrmCp(14);	mMngVrmCp(15);		//							12 - 15

	mMngVrmSp( 0);	mMngVrmSp( 1);	mMngVrmSp( 2);	mMngVrmSp( 3);		//	PsڂXy[XŖ 0 -  3
	mMngVrmSp( 4);	mMngVrmSp( 5);	mMngVrmSp( 6);	mMngVrmSp( 7);		//							 4 -  7
	mMngVrmSp( 8);	mMngVrmSp( 9);	mMngVrmSp(10);	mMngVrmSp(11);		//							 8 - 11
	mMngVrmSp(12);	mMngVrmSp(13);	mMngVrmSp(14);	mMngVrmSp(15);		//							12 - 15
}

//----------------------------------------------------------------------------
//	hFgAZu߂𗘗pĂ邱Ƃɒ						 -
//----------------------------------------------------------------------------
void	DevVrmFeed_3(void)
{
#asm																	//	CCAZuJn

	//	***** AhX *****

	movlw	low (_vMngVrm + 000h)										//	uq`lOsڂ̃AhXZbg
	movwf	fsr0l
	movlw	high(_vMngVrm + 000h)
	movwf	fsr0h

	movlw	low (_vMngVrm + 010h)										//	uq`lPsڂ̃AhXZbg
	movwf	fsr1l
	movlw	high(_vMngVrm + 010h)
	movwf	fsr1h

	//	***** PsڂOsڂɃRs[ *****

	moviw	[ 0]fsr1
	movwi	[ 0]fsr0

	moviw	[ 1]fsr1
	movwi	[ 1]fsr0

	moviw	[ 2]fsr1
	movwi	[ 2]fsr0

	moviw	[ 3]fsr1
	movwi	[ 3]fsr0

	moviw	[ 4]fsr1
	movwi	[ 4]fsr0

	moviw	[ 5]fsr1
	movwi	[ 5]fsr0

	moviw	[ 6]fsr1
	movwi	[ 6]fsr0

	moviw	[ 7]fsr1
	movwi	[ 7]fsr0

	moviw	[ 8]fsr1
	movwi	[ 8]fsr0

	moviw	[ 9]fsr1
	movwi	[ 9]fsr0

	moviw	[10]fsr1
	movwi	[10]fsr0

	moviw	[11]fsr1
	movwi	[11]fsr0

	moviw	[12]fsr1
	movwi	[12]fsr0

	moviw	[13]fsr1
	movwi	[13]fsr0

	moviw	[14]fsr1
	movwi	[14]fsr0

	moviw	[15]fsr1
	movwi	[15]fsr0

	//	***** PsڂXy[XŖ *****

	movlw	020h

	movwi	[ 0]fsr1
	movwi	[ 1]fsr1
	movwi	[ 2]fsr1
	movwi	[ 3]fsr1
	movwi	[ 4]fsr1
	movwi	[ 5]fsr1
	movwi	[ 6]fsr1
	movwi	[ 7]fsr1
	movwi	[ 8]fsr1
	movwi	[ 9]fsr1
	movwi	[10]fsr1
	movwi	[11]fsr1
	movwi	[12]fsr1
	movwi	[13]fsr1
	movwi	[14]fsr1
	movwi	[15]fsr1

#endasm																	//	CCAZuI
}

//============================================================================
//	uq`l̃NA
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	\e𑍂ċ󔒍sɂ܂B
//			s߁AJ܂߁AVXe\Ɉˑ܂B
//
//			̊֐͌XCɔzuĂ܂Ax̂߁A
//			VXe\ˑAJˑAfoCXˑ̏ɂȂĂ܂B
//			L̐ɂȂ̂ŃC䂩foCXɈړĂ܂B
//			ڐAsۂ͊g߂pł邩ۂ̊mFKvłB
//
//			43cycle = 5.375us
//============================================================================
void	DevVrmClear(void)
{
#asm																	//	CCAZuJn

	//	***** AhX *****

	movlw	low (_vMngVrm + 000h)										//	uq`lOsڂ̃AhXZbg
	movwf	fsr0l
	movlw	high(_vMngVrm + 000h)
	movwf	fsr0h

	//	***** 󔒃R[h *****

	movlw	020h

	//	***** Os *****

	movwi	[ 0]fsr0
	movwi	[ 1]fsr0
	movwi	[ 2]fsr0
	movwi	[ 3]fsr0
	movwi	[ 4]fsr0
	movwi	[ 5]fsr0
	movwi	[ 6]fsr0
	movwi	[ 7]fsr0
	movwi	[ 8]fsr0
	movwi	[ 9]fsr0
	movwi	[10]fsr0
	movwi	[11]fsr0
	movwi	[12]fsr0
	movwi	[13]fsr0
	movwi	[14]fsr0
	movwi	[15]fsr0

	//	***** Ps *****

	movwi	[16]fsr0
	movwi	[17]fsr0
	movwi	[18]fsr0
	movwi	[19]fsr0
	movwi	[20]fsr0
	movwi	[21]fsr0
	movwi	[22]fsr0
	movwi	[23]fsr0
	movwi	[24]fsr0
	movwi	[25]fsr0
	movwi	[26]fsr0
	movwi	[27]fsr0
	movwi	[28]fsr0
	movwi	[29]fsr0
	movwi	[30]fsr0
	movwi	[31]fsr0

#endasm																	//	CCAZuI
}

//	
//	
//
// 		̑
//
//	
//	
void	DevEtc______(void) {}											//	op֐

//============================================================================
//	vOo[W擾
//----------------------------------------------------------------------------
//	́F	i[AhX
//	óF	
//----------------------------------------------------------------------------
//	lF	ɐ`ꂽvOo[W擾܂B
//			mۂׂobt@̑傫 DEVLEN_VERSION QƊ肢܂B
//============================================================================
void	DevCfgGetPrgVer(UB *Buffer)
{
	*(Buffer + 0) = VER1 + '0';											//	P
	*(Buffer + 1) = VER2 + '0';											//	Q
	*(Buffer + 2) = '.';												//	؂
	*(Buffer + 3) = VER3 + '0';											//	R
	*(Buffer + 4) = VER4 + '0';											//	S
	*(Buffer + 5) = CODE_NUL;
}

//============================================================================
//	
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2011 PaletteSoft LLC

