
//	Copyright 2011 PaletteSoft LLC

//	*     *   ***   ******* *     *                                           
//	**   **  *   *     *    **    *                                           
//	* * * * *     *    *    * *   *                                           
//	*  *  * *     *    *    *  *  *                                           
//	*     * *******    *    *   * *                                           
//	*     * *     *    *    *    **                                           
//	*     * *     * ******* *     *                                           

// ===========================================================================
// =	CL^															 =
// ===========================================================================
//	002 2011.??.??
//	E
// ---------------------------------------------------------------------------
//	001 2011.02.15
//	EVK쐬
// ===========================================================================

//								 0123456789012345
#define	SYSTEM_NAME				"UART TEST"								//	VXe
#define	COPYRIGHT				"(C)2011 PS LLC"						//	쌠\

#define	MngVrmMain()			MngVrmTxtMain()							//	AvP[V̑I@c@AvP[Vo^ꍇɑΉ

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

	//	*****  *****

#include	<string.h>													//	񑀍

	//	***** 錾 *****

#include	"_AtrDef.h"													//	萔Af[^^̐錾
#include	"version.h"													//	o[Wԍ̒`

	//	*****  *****

#include	"device.h"													//	foCX
#include	"DrvLcd.h"													//	kbc
#include	"DrvCom.h"													//	t`qs

#define	ACT_MAIN														//	Cp̕ϐ̐錾v@c@foCXˑ̏𕪊邽
#include	"main.h"													//	C

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************


// ***************************************************************************
// *	\																 *
// ***************************************************************************


// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

	//	***** \ *****

UB		vMngDspX;														//	\ڈʒuij
UB		vMngDspY;														//	\ڈʒuisj

	//	***** uq`l *****

UB		vMngVrmX;														//	䒍ڈʒuij
UB		vMngVrmY;														//	䒍ڈʒuisj

BIT		vMngVrmReqFeed;													//	sVtgvtO

	//	***** ʐM ******

_UB		vMngRecvData;													//	Mf[^
uComSts	vMngRecvStatus;													//	MXe[^X

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

	//	***** VXe *****

const	UB		tSystemName[] = SYSTEM_NAME;							//	VXe̕
const	UB		tCopyright[] = COPYRIGHT;								//	쌠\

	//	*****  *****

const	UB		tCrLf[] = "\r\n";										//	bqCke

const	UB		tCnvHexAscL[16] = {										//	Srbg̐lPUȋ啶R[hɕϊ
	'0',	'1',	'2',	'3',	'4',	'5',	'6',	'7',
	'8',	'9',	'A',	'B',	'C',	'D',	'E',	'F',
};

	//	***** ʐMx *****

const	UB	*tMsgSpd[COM_SPEED_TOTAL] = {								//	\p
	"230400", "115200", "57600", "38400", "19200", "9600", "4800", "2400"
};

const	UB	tBpsCnv[COM_SPEED_TOTAL] = {								//	XCb`̌ڂ̔zu␳
	0b000,																//	off	off	off = 000 -> 000	230400bsp
	0b100,																//	on	off	off = 001 -> 100	115200bps
	0b010,																//	off	on	off	= 010 -> 010	 57600bps
	0b110,																//	on	on	off	= 011 -> 110	 38400bps
	0b001,																//	off	off	on	= 100 -> 001	 19200bps
	0b101,																//	on	off	on	= 101 -> 101	  9600bps
	0b011,																//	off	on	on	= 110 -> 011	  4800bps
	0b111,																//	on	on	on	= 111 -> 111	  2400bps
};

// ***************************************************************************
// *	}N																 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv														 *
// ***************************************************************************

	//	***** }lWg *****

void	MngIniHard(void);
void	MngIniSoft(UB Speed);
UB		MngIniGetBps(UB SwData);

	//	***** \ *****

void	MngDspInit(void);
void	MngDspMain(void);

	//	***** uq`l *****

void	MngVrmInit(void);
void	MngVrmClear(void);
void	MngVrmChkFeed(void);

	//	***** uq`lFeLXg\ *****

void	MngVrmTxtMain(void);

	//	***** Cu *****

UB*		LibHexAscUB(UB *Buffer, UB Value);

// ***************************************************************************
// *																	 *
// ***************************************************************************

#include	"__debug__.h"												//	P̃fobO@\i쎞̒g͋ɂȂ܂j

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	ʁiӖj
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
int		main(void)
{
	UB		Speed;														//	ʐMx

	//	***** ͂߂ *****

	di();																//	CIɊ荞݋֎~
	mDebugMain();														//	P̃fobOiKvȏꍇ̂ݓWJj

	//	***** ݒ *****

	MngIniHard();														//	}lWgݒFn[h

	Speed = MngIniGetBps(DevSigSwRead());								//	XCb`̏ԂʐMx擾
	MngIniSoft(Speed);													//	}lWgݒF\tg

	//	***** ^p *****

	while (DevTimCycGetReq() == FALSE)	;								//	^C}̃^CAEg҂@Pځ@c@t[^C}̏h
	while (DevTimCycGetReq() == FALSE)	;								//	^C}̃^CAEg҂@Qځ@c@Ő͂

	//	***** ʐMJn *****

	DrvComSetCfg(Speed);												//	ʐMݒ					@ݒ肳ĂʐMxp
	DrvComModeAct(DISABLE);												//	ʐMJni荞݋֎~[hj@@|[O[hI
	RCIE = 1;															//	M荞݂̋				@}jAbNȐɂȂ܂

#if 0
	DrvComPutC(0x55);													//	ʐMxmFpiM̌`́A0 10101010 1j
#endif

	//	***** Jn *****

	ei();																//	荞݋

	//	*****  *****

	while (1) {															//	

		//	*****  *****

		if (DevTimCycGetReq()) {										//	^C}̃^CAEgH
			MngDspMain();												//	\@c@AĂǂǁAĕU
		}

		//	***** 펞 *****

		;																//	KvɉĐ

		CLRWDT();														//	EHb`hbO^C}̃tbViCIȍ@j
	}

	//	***** ܂ *****

	return(0);															//	ԂlɈӖ͎ȂiĂAɂ͂Ȃ͂j
}

//============================================================================
//	}lWgݒFn[h
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCXݒ肵܂B
//============================================================================
void	MngIniHard(void)
{
	//	***** { *****

	DevInit();															//	foCXݒ
	DevTimCycInit();													//	^C}N@c@t[^C}Ȃ̂ŁA[ƓĂ

	//	***** t`qs *****

	DrvComInit();														//	ʐMݒ

	//	***** kbc *****

	DrvLcdInit1();														//	kbcݒP
	DevTimWaiMs(5);														//	Tҋ@
	DrvLcdInit2();														//	kbcݒQ
}

//============================================================================
//	}lWgݒF\tg
//----------------------------------------------------------------------------
//	́F	ʐMx
//	óF	
//----------------------------------------------------------------------------
//	lF	NbZ[W\Aݒ肵܂B
//
//				0123456789012345
//			0	UART TEST  XX.XX
//			1	XXXXXXbps    ???
//============================================================================
void	MngIniSoft(UB Speed)
{
	UB		Buffer[DEVLEN_VERSION];										//	o[Wԍ
	BOOL	Result;														//	ێ

	//	***** kbc\ *****

	DrvLcdLoc( 0, 0);													//	\Wݒ
	DrvLcdPutS(tSystemName);											//	VXe̕\

	DrvLcdLoc(11, 0);													//	\Wݒ
	DevCfgGetPrgVer(Buffer);											//	o[Wԍ擾
	DrvLcdPutS(Buffer);													//	o[Wԍ\

	DrvLcdLoc( 0, 1);													//	\Wݒ
	DrvLcdPutS(tMsgSpd[Speed]);											//	ʐMx̐ݒǂݏoĕ\
	DrvLcdPutS("bps");													//	Pʂ\

#if 1
	DrvLcdLoc(13, 1);													//	\Wݒ
	DrvLcdPutS(DevSigSwRead() & (UB)SW_ETC ? "On" : "Off");				//	ėpXCb`̏Ԃ\
#endif

	//	***** ݒ *****

	MngDspInit();														//	\
	MngVrmInit();														//	uq`l

	//	***** \ҋ@ *****

#ifdef	__RELEASE														//	[X[hH
	DevTimWaiSec(2);													//	\̈ێ
#endif

	DrvLcdClr();														//	\NA
}

//============================================================================
//	ʐMx擾
//----------------------------------------------------------------------------
//	́F	XCb`̏
//	óF	ʐMxԍ
//----------------------------------------------------------------------------
//	lF	XCb`̏ԂÐ^xԍ擾܂B
//
//			ʐMxXCb`AėpXCb`̓p[^Ƃ܂Ał
//			ėpXCb`̃`FbN͍s܂B
//============================================================================
UB		MngIniGetBps(UB SwData)
{
	UB		Speed;														//	ʐMx

	Speed = tBpsCnv[SwData & (UB)SW_BPS];								//	ݒ肳ĂʐMx擾

	return(Speed);														//	ʐMxԂ܂
}

//	
//	
//
// 		荞
//
//	
//	
void	MngIpt______(void) {}											//	op֐

//============================================================================
//	荞
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	荞ݏłB
//============================================================================
extern	uComSts	vComSts;												//	MXe[^X			@O錾BڎQƂ邱ƂɒӁB
void	interrupt	MngIpt(void)
{
	//	********************************
	//	***** t`qsM荞 *****
	//	********************************

/*
	ʐMhCo֐𗘗pĎMf[^擾Auq`l̕ҏWs܂B

	őʐMx230400bps͖43.41usŎM荞݂̂ŁA̎
	ő̊荞ݏ܂߂Ċ荞ݏIȂ΂Ȃ܂B̓A
	CŊ荞݋֎~܂܂ꍇ́A̎ԂlKv܂B

	̊荞ݏ̓Cu̓cŁA|[O荞
	݋ԂŗpĂ܂BXe[^X̒ڎQƂsxD
	̂łéB

	őʐMxA菇iłEGJjƂ󋵂͗OƂ
	vOɂȂĂ܂܂B

	9600bpsʂȂ瑍ăCuł薳̂ǁBƁA`V̗B
*/

#if 0																	//	Cugpꍇ	c@͊ԈႢł͂ȂAނ됳h

	if (DrvComChkC()) {													//	Mf[^H
		vMngRecvData = DrvComGetC();									//	|[Oł̃oCgf[^M
		DrvComGetSts(&vMngRecvStatus);									//	ʐMXe[^X擾
		MngVrmMain();													//	uq`l
	}

#else																	//	xl\			c@ԈႢł͂ȂAxd

	if (RCIF) {															//	Mf[^H		@}CR̓ꐧ䃌WX^𒼐ڎQ
		vMngRecvData = DrvComGetC();									//	|[Oł̃oCgf[^M
		vMngRecvStatus.BYTE = vComSts.BYTE;								//	MXe[^X擾	@ϐ𒼐ڎQƁi荞ݐȗ邽߁j
		vComSts.BYTE = 0;												//	MXe[^XNA	@ϐ𒼐ڑiCuł̍Ƃsj
		MngVrmMain();													//	uq`l
	}

#endif

	//	************************
	//	***** HH荞 *****
	//	************************

	;																	//	KvɉĒ`
}

//	
//	
//
// 		\
//
//	
//	
void	MngDsp______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	\̏ݒs܂B
//============================================================================
void	MngDspInit(void)
{
	vMngDspX = 0;														//	QƍWO
	vMngDspY = 0;														//	QƍWOs
}

//============================================================================
//	\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uq`l̓ekbcɓ]܂B
//			iWjĂяoÂ݂uq`lf[^S
//			Pʂœ]܂B
//			gpfoCX͂PUQsȂ̂ŁAWƂuq`l̓
//			e𑍂ē]ł邱ƂɂȂ܂BXV[g15.6fpsłB
//			܂AGł͂ȂȂ̂ł܂XVxƌȂłB
//
//			͂uq`lXVLɂ炸\s܂
//============================================================================
void	MngDspMain(void)
{
	UB		Loop;														//	[vJE^
	UB		*Pointer;													//	uq`l擾ʒu

	//	***** kbc\ *****

	DrvLcdLoc(vMngDspX, vMngDspY);										//	̎QƍWZbg

	Pointer = &vMngVrm[vMngDspY][vMngDspX];								//	uq`l擾ʒuZo

	for (Loop=0; Loop<4; Loop++) {										//	S]
		DrvLcdPutC(*Pointer);											//	P\
		Pointer ++;														//	ʒuXV
	}

	//	***** ʒuXV *****

	vMngDspX += 4;														//	ʒuXV
	if (vMngDspX >= LCD_COL_TOTAL) {									//	ʒu͉E[zH
		vMngDspX = 0;													//	ʒu[Ɉړ

		//	***** sʒuXV *****

		vMngDspY ++;													//	sʒuXV
		if (vMngDspY >= LCD_ROW_TOTAL) {								//	sʒu͉[zH
			vMngDspY = 0;												//	sʒu[Ɉړ
		}
	}
}

//	
//	
//
// 		uq`l
//
//	
//	
void	MngVrm______(void) {}											//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	uq`l̏ݒs܂B
//============================================================================
void	MngVrmInit(void)
{
	//	***** ʏ *****

	MngVrmClear();														//	ʏ

	//	***** Ǘ *****

	;																	//	KvɉĒǉ
}

#if 0																	//	@֐uŖ{֐͎s܂@
//============================================================================
//	uq`l
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	MPoCg̃f[^ɂuq`ls܂B
//				vMngRecvData@	c@Mf[^
//				vMngRecvStatus	c@MXe[^XiOۂŔf\j
//			{֐͎M荞݂ĂяôŏԂɂ͒ӂKvłB
//============================================================================
void	MngVrmMain(void)
{
	;
}
#endif

//============================================================================
//	ʏ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	ʏsڈʒuiOAOsjɃZbg܂B
//============================================================================
void	MngVrmClear(void)
{
	DevVrmClear();														//	uq`l̃NA

	vMngVrmX = 0;														//	ʒuO
	vMngVrmY = 0;														//	ʒuOs

	vMngVrmReqFeed = 0;													//	sVtgv̉
}

//============================================================================
//	sVtgff
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	sVtgv̗LmFčsVtgs܂B
//============================================================================
void	MngVrmChkFeed(void)
{
	if (vMngVrmReqFeed) {												//	sVtgvH
		vMngVrmReqFeed = 0;												//	v
		DevVrmFeed();													//	sVtgs
	}
}

//	
//	
//
// 		uq`lFeLXg\
//
//	
//	
void	MngVrmTxt______(void) {}										//	op֐

//============================================================================
//	eLXg\
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	MPoCg̃f[^eLXg\܂B
//				vMngRecvData@	c@Mf[^
//				vMngRecvStatus	c@MXe[^XiOۂŔf\j
//			ėpIɍĂ銄ɂ͐R[h̎舵PUQsɂȂ
//			܂܂B
//
//			V~[Vɂ鏈ԑł̍ňĺAPsځiij
//			ŉsR[hɂsVtgvĂԂł̂P͂łB
//			AĔ邱Ƃ͂܂񂪁ȀԂ21.0usv܂B
//============================================================================
void	MngVrmTxtMain(void)
{
	//	***** ͂߂ *****

	if (vMngRecvStatus.BYTE != 0) {										//	MG[oH
		return;															//	MR[h𖳎i󂯎̂ājċI
	}

	//	***** MR[hɉĐ *****

	if ((vMngRecvData & (UB)0xf0) == (UB)0x10) {						//	ʒuwH	c@0x10 ` 0x1f
		vMngVrmX = vMngRecvData & (UB)0x0f;								//	ʒuĐݒ
	}
	else {																//	R[hA

		switch (vMngRecvData) {											//	MR[hɉĕ

			//	***** ̑̕ *****

			default:
				MngVrmChkFeed();										//	sVtgff
				vMngVrm[vMngVrmY][vMngVrmX] = vMngRecvData;				//	R[hZbg@c@|C^łǂǁAWǗ̂Ŕz
				vMngVrmX ++;											//	ʒuړ
				if (vMngVrmX >= LCD_COL_TOTAL) {						//	E[zH
					vMngVrmX = 0;										//	[Ɉړ
					if (vMngVrmY == 0) 	vMngVrmY = 1;					//	݂OsڂȂ琧ʒuPsڂɈړ
					else 				vMngVrmReqFeed = 1;				//	݂PsڂȂsVtgv
				}
				break;

			//	*****  *****

			case CODE_FF:
				MngVrmClear();											//	ʏ
				break;

			//	***** A *****

			case CODE_CR:
				vMngVrmX = 0;											//	ʒuO
				break;

			//	***** s *****

			case CODE_LF:
				MngVrmChkFeed();										//	sVtgff
				if (vMngVrmY == 0) 	vMngVrmY = 1;						//	݂OsڂȂ琧ʒuPsڂɈړ
				else 				vMngVrmReqFeed = 1;					//	݂PsڂȂsVtgv
				break;

			//	***** Os *****

			case CODE_SO:
				MngVrmChkFeed();	vMngVrmY = 0;						//	sVtgffAʒuOs
				break;

			//	***** Ps *****

			case CODE_SI:
				MngVrmChkFeed();	vMngVrmY = 1;						//	sVtgffAʒuPs
				break;
		}
	}
}

/*
	N	-----				
			ʂAڍWiOAOsjɈړ܂B
			sVtg[h͉܂B

		FF					10.625us(32MHz)
			uq`l𑍂ċ󔒂ŖAڈʒuiOAOsjɈړ܂B

		-----				11.75us - 21.0us
			R[huq`lɃZbgAڈʒuEɈړ܂B
			OsډE[ŕ͂ƁAuq`lZbgɒڍW͂Psڍ[ɂȂ܂B
			PsډE[ŕ͂ƁAuq`lZbgɒڍW͂Psڍ[ɂȂ܂BsVtg[hłB
			sVtg[hɓ͂ƍŏ̍ƂƂčsVtgsAsVtg[h܂B

			sVtg[h͂PsڂOsڂɃRs[APsڂ󔒂ŖƂłB
			\̈ł\Ԃێ邽߂̍׍HłB
			Ⴆ΁Af[^CR/LFAf[^CR/LF󂯂ƂAPs\ɂȂ邩AQs\̂̈ႢɂȂ܂B

	A	CR					4.5us
			ڍW[Ɉړ܂B̎Asʒu͕ێ܂B
			sVtg[h͎sꂸAێ܂B

	s	LF					6.0us - 14.125us
			ڈʒuPs炵܂B
			Osڂœ͂ƂPsڂɈړ܂B
			Psڂœ͂ƈʒu͕ς炸AsVtg[hłB
			sVtg[hɓ͂ƍŏ̍ƂƂčsVtgsAsVtg[h܂B

	Os	SO 0x0e(00001110)	6.375us - 14.5us
			ڈʒuOsڂɂ܂B
			sVtg[hɓ͂ƍŏ̍ƂƂčsVtgsAsVtg[h܂B

	Ps	SI 0x0f(00001111)	7.0us - 15.125us
			ڈʒuPsڂɂ܂B
			sVtg[hɓ͂ƍŏ̍ƂƂčsVtgsAsVtg[h܂B

	ʒu	0x1?(0001????)		3.5us
			ڈʒuʂSrbgŎʒuɈړ܂B̎Asʒu͕ێ܂B
			sVtg[h͎sꂸAێ܂B
*/

//	
//	
//
// 		uq`lFHHHH\
//
//	
//	
void	MngVrmXXX______(void) {}										//	op֐

//============================================================================
//	
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================

//	
//	
//
// 		Cu
//
//	
//	
void	Lib______(void) {}												//	op֐

//============================================================================
//	PoCglPUiɕϊ
//----------------------------------------------------------------------------
//	́F	i[obt@iQ{PjAlA
//	óF	i[obt@
//----------------------------------------------------------------------------
//	lF	PoCglQ̂PUiɕϊ܂B
//============================================================================
UB*		LibHexAscUB(UB *Buffer, UB Value)
{
	Buffer[0] = tCnvHexAscL[Value >> 4];								//	ʂSrbgϊ
	Buffer[1] = tCnvHexAscL[Value & 0x0f];								//	ʂSrbgϊ
	Buffer[2] = CODE_NUL;												//	I[R[hZbg

	return(Buffer);														//	obt@AhXԂ܂
}

//============================================================================
//	
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	
//============================================================================

// ***************************************************************************
// *																		 *
// ***************************************************************************

//	Copyright 2011 PaletteSoft LLC

